#ifndef GBPAD_GBPAD_H_
#define GBPAD_GBPAD_H_


#define GBPAD_RIGHT  0x01
#define GBPAD_LEFT   0x02
#define GBPAD_UP     0x04
#define GBPAD_DOWN   0x08
#define GBPAD_A      0x10
#define GBPAD_B      0x20
#define GBPAD_SELECT 0x40
#define GBPAD_START  0x80



#include "controller.h"

class GB_pad : public controller
{
	uint8 inp_state;

public:
	GB_pad()
	{
		inp_state = 0x00;
	}
	~GB_pad() {}

	void set_button_state(int button, boolean pressed)
	{
		if(pressed)
		{
			inp_state |= button;
		}
		else
		{
			inp_state &= (0xFF - button);
		}
	}

	boolean is_pressed(int button)
	{
		return (inp_state & button);
	}

	void release_all_buttons() { inp_state = 0x00; }

	uint8 get_inp_state()
	{
		uint8 temp = inp_state;

		// up and down cancel out
		if((GBPAD_UP | GBPAD_DOWN) == (temp & (GBPAD_UP | GBPAD_DOWN)))
		{
			temp &= 0xFF - (GBPAD_UP | GBPAD_DOWN);
		}

		// left and right cancel out
		if((GBPAD_LEFT | GBPAD_RIGHT) == (temp & (GBPAD_LEFT | GBPAD_RIGHT)))
		{
			temp &= 0xFF - (GBPAD_LEFT | GBPAD_RIGHT);
		}

		return temp;
	}
};

#endif

