
#ifndef _GAMEBOY_H_
#define _GAMEBOY_H_

#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include "screen_mgr.h"
#include "sound_mgr.h"
#include "GB_screen_mgr.h"
#include "GB_mem.h"
#include "GB_hw.h"
#include "GB_rtc.h"
#include "GB_fb.h"
#include "GB_lcd.h"
#include "GB_pcm.h"
#include "GB_sound.h"
#include "NES_6502.h"


typedef struct gb_apudata_s
{
	int timestamp;
	uint32 address;
	uint8 value;
} gb_apudata_t;


#define I1(s, p) { 1, s, p }
#define I2(s, p) { 2, s, p }
#define I4(s, p) { 4, s, p }
#define R(r) I1(#r, &R_##r)
#define NOSAVE { -1, "\0\0\0\0", 0 }
#define END { 0, "\0\0\0\0", 0 }

struct svar
{
	int len;
	char key[4];
	void *ptr;
};


#define  GB_APUQUEUE_SIZE  4096
#define  GB_APUQUEUE_MASK  (GB_APUQUEUE_SIZE - 1)


class GAMEBOY
{
public:
	GAMEBOY(const char* ROM_name, GB_screen_mgr* _screen_mgr, sound_mgr* _sound_mgr,HWND parent_window_handle);
	~GAMEBOY();
	const char* getROMname(){ return (const char *)ROMname;} // returns ROM name without extension
	const char* getROMpath(){ return (const char *)ROMPath;}

	boolean loadState(const char* fn);
	boolean saveState(const char* fn);
	void writeBaram(unsigned char* adr){ return;}
	void readBaram(unsigned  char* adr){ return;}
	void ReadBoneb(unsigned int addr, unsigned char *data){ return;}
	void WriteBoneb(unsigned int addr, unsigned char data){ return;}
	void writeSraram(unsigned char* adr){ return;}
	void readSraram(unsigned  char* adr){ return;}
	void ReadSroneb(unsigned int addr, unsigned char *data){ return;}
	void WriteSroneb(unsigned int addr, unsigned char data){ return;}
	unsigned char GetScreenMode(){ return 1;}
	void nnnKailleraClient(){ return;}
	void GetROMInfoStr(char *wt);
	uint32 crc32(){ return 0;}
	void Load_Genie(){ return;}


	uint32 GetMainMemp(uint8 **p){ *p = MainMem; return 0x4000; };
	uint32 GetSramMemp(uint8 **p){ *p = CartRAM; return CartRAMSize; };
	uint32 GetExtMemp(uint8 **p){ *p = Hi_Memory; return 0x200; }//*p = mapper_extram; return mapper_extramsize; };
	uint32 Get_PPUMemp(uint8 **p){ 
		int i;
		for(i=0; i<8; i++){ p[i] = &lcd.vbank[0][i*0x400]; }
		for(i=0; i<4; i++){ p[i+8] = &lcd.vbank[1][i*0x400]; }
//		p[12] = ppu->bg_pal;
//		p[13] = ppu->spr_pal;
		return 12;
	}
	void GetCPUContext(unsigned char *context);

	boolean emulate_frame(boolean draw);

	void reset(unsigned char);

	void set_pad(unsigned char* c){ Pad = c; }
	/*
	  void set_pad2(controller* c) {}
	  void set_pad3(controller* c) {}
	  void set_pad4(controller* c) {}
	*/
//	void set_micbits(unsigned char* c){ return;}

	void input_settings_changed(){ return;}

	// sound
	void enable_sound(boolean enable) { return;}
	boolean sound_enabled() { return FALSE; }
	boolean set_sample_rate(int sample_rate) { return FALSE; }
	int get_sample_rate() { return 0; }

	void freeze(){ 
		snd_mgr->clear_buffer();
		is_frozen = TRUE; }
	void thaw(){ 
		currently_playing_half = snd_mgr->get_currently_playing_half();
		is_frozen = FALSE;}

	boolean frozen(){ return is_frozen;}
	/*
	  uint8 GetDiskSideNum(){ return 0;}
	  uint8 GetDiskSide(){ return 0;}
	  void SetDiskSide(uint8 side){ return;}
	  uint8 DiskAccessed() { return 0;}

	  void SetExControllerType(uint8 num){ return;}
	  uint8 GetExControllerType(){ return 0;}
	  void SetBarcodeValue(uint32 value_low, uint32 value_high){ return;}

	  void StopTape(){ return;}
	  void StartPlayTape(const char* fn){ return;}
	  void StartRecTape(const char* fn){ return;}
	  uint8 GetTapeStatus(){ return 0;}
	*/

	// for Movie
	void StopMovie(){ return;}
	void StartPlayMovie(const char* fn){ return;}
	void StartRecMovie(const char* fn, unsigned char mflag){ return;}
	uint8 GetMovieStatus(){ return 0;}
	void StartPlayToRecMovie(){ return;}

/*
	BYTE readmem(WORD address);
	void writemem(WORD address, BYTE data);
	//void push_pc(void);
	WORD readmem_word(WORD address);
	void writemem_word(WORD address, WORD data);
*/
	int LoadROM(HWND hWnd, char *FileName);
	void GetGameTitleName(char *s){ strcpy(s, ROMTitle); }

	void mbc_reset();
	byte mem_read(int a);
	void mem_write(int a, byte b);
	void mbc_write(int a, byte b);
	byte ioreg_read(int r);
	void ioreg_write(int r, byte b);
	void mem_updatemap();

	void get_himemp(unsigned char **p){ *p = Hi_Memory; };
//#define C (cpu.lcdc)

	void stat_trigger();
	void stat_write(byte b);
	void stat_change(int stat);
	void lcdc_change(byte b);
	void lcdc_trans();
	void cpu_reset();


	void lcd_reset();
	void pal_dirty();
	void vram_dirty();
	void vram_write(int a, byte b);
	void pal_write_dmg(int i, int mapnum, byte d);
	void pal_write(int i, byte b);
	void updatepalette(int i);
	void lcd_refreshline();
	void lcd_begin();
	void spr_scan();
	void spr_enum();
	void spr_count();
	void recolor(byte *buf, byte fill, int cnt);
	void wnd_scan_color();
	void bg_scan_color();
	void wnd_scan_pri();
	void bg_scan_pri();
	int  priused(void *attr);
	void blendcpy(byte *dest, byte *src, byte b, int cnt);
	void wnd_scan();
	void bg_scan();
	void tilebuf();
	void updatepatpix();

	void hw_interrupt(byte i, byte mask);
	void hw_dma(byte b);
	void hw_hdma_cmd(byte c);
	void hw_hdma();
	void pad_refresh();
	void pad_press(byte k);
	void pad_release(byte k);
	void pad_set(byte k, int st);
	void pad_check();

	void hw_reset();


	void SetROMBank4000H(DWORD n);

	void rtc_latch(byte b);
	void rtc_write(byte b);
	void rtc_tick();
	void rtc_save_internal(FILE *f);
	void rtc_load_internal(FILE *f);

	byte bestmatch(int c);
	void makecourse(int c, byte n);
	byte findcourse(int c);
	void pal_lock(byte n);
	byte pal_getcolor(int c, int r, int g, int b);
	void pal_release(byte n);
	void pal_expire();
	void pal_set332();


	void new_snd_mgr(sound_mgr* _sound_mgr);

	void s1_freq_d(int d);
	void s1_freq();
	void s2_freq();
	void s3_freq();
	void s4_freq();
	void sound_dirty();
	void sound_off();
	void sound_reset();
	void sound_mix();
	byte sound_read(int r);
	void s1_init();
	void s2_init();
	void s3_init();
	void s4_init();
	void sound_write(int r, byte b);
	void pcm_submit();


	void apu_enqueue(gb_apudata_t *d);
	gb_apudata_t *apu_dequeue(void);
	void apu_process();


private:
	GB_screen_mgr* scr_mgr;
	sound_mgr* snd_mgr;
	boolean is_frozen;
	HWND main_window_handle;

	char ROMname[MAX_PATH];
	char ROMPath[MAX_PATH];

	unsigned char *Pad;

	unsigned char MainMem[0x4000];
//	unsigned char VideoMem[0x4000];
	unsigned char *CartRAM;
	unsigned char *ROMimage;
//	unsigned int ROMFileSize;
	unsigned int CartRAMSize;
	int mbc_type;
	int mbc_batt;
	int mbc_romsize;
	int mbc_ramsize;
	int mbc_rombank;
	int mbc_rambank;
	int mbc_enableram;
	int mbc_model;

	char ROMTitle[0x16];
	unsigned char Hi_Memory[0x200];

	byte palmap[32768];
	byte pallock[256];
	int palrev[256];
	/* Course color mapping, for when palette is exhausted. */
	byte crsmap[4][32768];
	int crsrev[4][256];

	int scale;
	int density;
	int rgb332;
	int sprsort;
	int sprdebug;

	byte *vdest;

	byte patpix[4096][8][8];
	byte patdirty[1024];
	byte anydirty;


	struct lcd lcd;
	struct scan scan;
	struct snd snd;
	struct pcm pcm;
	sound_buf_pos currently_playing_half;
	gb_apudata_t apu_queue[GB_APUQUEUE_SIZE];
	int apu_qreadp;
	int apu_qwritep;

		int swpClk;
		int envClk;
		int lenClk;
		int freqClk;
		int freq4Clk;
		
		int snd1Enable,snd1Freq,snd1Vol,snd1Len,snd1SwpCnt;
		int snd1EnvCnt,snd1Bit,snd1ValL,snd1ValR,snd1Cnt;
		int snd2Enable,snd2Freq,snd2Vol,snd2Len;
		int snd2EnvCnt,snd2Bit,snd2ValL,snd2ValR,snd2Cnt;
		int snd3Enable,snd3Freq,snd3Len,snd3Bit,snd3Cnt;
		int snd3ValL,snd3ValR;
		int snd4Enable,snd4Freq,snd4Vol,snd4Len;
		int snd4EnvCnt,snd4Bit,snd4ValL,snd4ValR,snd4Cnt;



	struct hw hw;
	struct rtc rtc;
	struct fb fb;

//	struct mbc mbc;


	void Save_SaveRAM();
	void Load_SaveRAM();

protected:

};



#endif
