
#ifndef _PCE_H_
#define _PCE_H_

#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include "screen_mgr.h"
#include "sound_mgr.h"
#include "PCE_screen_mgr.h"

#include "h6280.h"
#include "vdc.h"
#include "vce.h"
#include "render.h"
#include "system.h"
#include "psg.h"
#include "cpuintrf.h"
//#include "osd.h"

typedef struct pce_apudata_s
{
	int timestamp;
	uint32 address;
	uint8 value;
} pce_apudata_t;


struct CDROM_IO
{
	uint8	CD_IO[0x10];
	uint8	CD_ReadBuffer[2048];
	int		CD_ReadPos;
	int		CD_ReadSize;
};


#define PCE_FAST_MEM

#define  PCE_APUQUEUE_SIZE  4096
#define  PCE_APUQUEUE_MASK  (PCE_APUQUEUE_SIZE - 1)


class PCE
{
public:
	PCE(const char* ROM_name, PCE_screen_mgr* _screen_mgr, sound_mgr* _sound_mgr,HWND parent_window_handle);
	~PCE();
	const char* getROMname(){ return (const char *)ROMname;} // returns ROM name without extension
	const char* getROMpath(){ return (const char *)ROMPath;}

	boolean loadState(const char* fn){ return 0;}
	boolean saveState(const char* fn){ return 0;}
	void writeBaram(unsigned char* adr){ return;}
	void readBaram(unsigned  char* adr){ return;}
	void ReadBoneb(unsigned int addr, unsigned char *data){ return;}
	void WriteBoneb(unsigned int addr, unsigned char data){ return;}
	void writeSraram(unsigned char* adr){ return;}
	void readSraram(unsigned  char* adr){ return;}
	void ReadSroneb(unsigned int addr, unsigned char *data){ return;}
	void WriteSroneb(unsigned int addr, unsigned char data){ return;}
	unsigned char GetScreenMode(){ return 1;}
	void nnnKailleraClient(){ return;}
	void GetROMInfoStr(char *wt);
	uint32 crc32(){ return RomCRC;}
	void Load_Genie(){ return;}


	uint32 GetMainMemp(uint8 **p){ *p = ram; return 0x8000; };
	uint32 GetSramMemp(uint8 **p){ *p = bram; return 0x2000; };
	uint32 GetExtMemp(uint8 **p){ *p = rom; return ROM_size; }//*p = mapper_extram; return mapper_extramsize; };
	uint32 Get_PPUMemp(uint8 **p){ 
		int i;
		for(i=0; i<12; i++){ p[i] = &vram[i*0x400]; }
//		p[12] = ppu->bg_pal;
//		p[13] = ppu->spr_pal;
		return 0;
	}

	boolean emulate_frame(boolean draw);

	void reset(unsigned char);

	void set_pad(unsigned char* c){
		for(int i=0; i<5; i++){
			Pad[i] = c+(i*2);
		}
	}
	/*
	  void set_pad2(controller* c) {}
	  void set_pad3(controller* c) {}
	  void set_pad4(controller* c) {}
	*/
//	void set_micbits(unsigned char* c){ return;}

	void input_settings_changed(){ return;}

	// sound
	void enable_sound(boolean enable) { return;}
	boolean sound_enabled() { return FALSE; }
	boolean set_sample_rate(int sample_rate) { return FALSE; }
	int get_sample_rate() { return 0; }

	void freeze(){ 
		snd_mgr->clear_buffer();
		is_frozen = TRUE; }
	void thaw(){ 
		currently_playing_half = snd_mgr->get_currently_playing_half();
		is_frozen = FALSE;}

	boolean frozen(){ return is_frozen;}
	/*
	  uint8 GetDiskSideNum(){ return 0;}
	  uint8 GetDiskSide(){ return 0;}
	  void SetDiskSide(uint8 side){ return;}
	  uint8 DiskAccessed() { return 0;}

	  void SetExControllerType(uint8 num){ return;}
	  uint8 GetExControllerType(){ return 0;}
	  void SetBarcodeValue(uint32 value_low, uint32 value_high){ return;}

	  void StopTape(){ return;}
	  void StartPlayTape(const char* fn){ return;}
	  void StartRecTape(const char* fn){ return;}
	  uint8 GetTapeStatus(){ return 0;}
	*/

	// for Movie
	void StopMovie(){ return;}
	void StartPlayMovie(const char* fn){ return;}
	void StartRecMovie(const char* fn, unsigned char mflag){ return;}
	uint8 GetMovieStatus(){ return 0;}
	void StartPlayToRecMovie(){ return;}

/*
	BYTE readmem(WORD address);
	void writemem(WORD address, BYTE data);
	//void push_pc(void);
	WORD readmem_word(WORD address);
	void writemem_word(WORD address, WORD data);
	*/
	int LoadROM(HWND hWnd, char *FileName);
	void GetGameTitleName(char *s){ strcpy(s, ROMTitle); }
	
	void apu_enqueue(pce_apudata_t *d);
	pce_apudata_t *apu_dequeue(void);
	void apu_process();
	void new_snd_mgr(sound_mgr* _sound_mgr);
	
	
	void pce_reset(void);
	void pce_shutdown(void);
	
	void audio_init(int rate);

	void system_shutdown(void);
	
	/*--------------------------------------------------------------------------*/
	/* Memory handlers                                                          */
	/*--------------------------------------------------------------------------*/
	
	
//	int pce_irq_callback(int irqline);
	void io_page_w(int address, int data);
	int io_page_r(int address);
	void input_w(uint8 data);
	uint8 input_r(void);

	void CDROM_IO_W(int address, uint8 data);
	uint8 CDROM_IO_R(int address);

#ifdef PCE_FAST_MEM
		void bank_reset(void);
	void bank_set(int bank, int value);
#else
	int cpu_readmem21(int address);
	void cpu_writeport16(int port, int data);
	void cpu_writemem21(int address, int data);
#endif
	

	void vce_w(int address, int data);
	int vce_r(int address);
	
	/*--------------------------------------------------------------------------*/
	/* Init, reset, shutdown routines                                           */
	/*--------------------------------------------------------------------------*/
	int psg_init(void);
	void psg_reset(void);
	void psg_shutdown(void);
	void psg_w(uint16 address, uint8 data);
//	void psg_update(int16 *bufl, int16 *bufr, int length);
	
	int vdc_r(int offset);
	void vdc_w(int offset, int data);
	int vdc_init(void);
	void vdc_reset(void);
	void vdc_shutdown(void);
	void vdc_do_dma(void);
	
	int render_init(void);
	void render_reset(void);
	void render_shutdown(void);
	int make_sprite_list(void);
	void update_bg_pattern_cache(void);
	void update_obj_pattern_cache(void);
	void render_line(int line);
	void render_bg(int line);
	void render_obj(int line);
	
	void KailleraClientProc();

private:
	PCE_screen_mgr* scr_mgr;
	sound_mgr* snd_mgr;
	boolean is_frozen;
	HWND window_handle;

//	M6502 *CPU;
	unsigned int	KailleraCounter;
	unsigned char	nnnKaillerapad[6];


	int ROM_size;
	DWORD RomCRC;

	/* System memory */
	uint8 ram[0x8000];      /* Work RAM */
	uint8 cdram[0x10000];   /* CD unit RAM (64k) */
	uint8 bram[0x2000];     /* Backup RAM (8K) */
	uint8 rom[0x100000];    /* HuCard ROM (1MB) */
	uint8 save_bram;        /* 1= BRAM registers were accessed */

	/* I/O port data */
	uint8 joy_sel;
	uint8 joy_clr;
	uint8 joy_cnt;

	// CD-ROM
	struct CDROM_IO CDROM2;


	int bitdepth;

	t_bitmap bitmap;
	t_input input;
	t_snd snd;
	
	t_vce vce;
	
	t_psg psg;
	
	
	uint32 y_offset;
	uint32 byr;
	uint8 vram[0x10000];
	uint16 reg[0x20];
	uint8 objram[0x200];
	uint8 status;
	uint8 latch;
	uint8 addr_inc;
	uint8 vram_data_latch;
	uint8 dvssr_trigger;
	int playfield_shift;
	uint32 playfield_col_mask;
	uint32 playfield_row_mask;
	int disp_width;
	int disp_height;
	uint32 disp_nt_width;
	uint16 *vramw;
	uint16 *objramw;
	int old_width;
	int old_height;
	int playfield_shift_table[4];
	int playfield_row_mask_table[4];
	
	
	uint8 bg_name_dirty[0x800];
	uint16 bg_name_list[0x800];
	uint16 bg_list_index;
	uint8 bg_pattern_cache[0x20000];

	uint16 obj_name_dirty[0x200];
	uint16 obj_name_list[0x200];
	uint16 obj_list_index;
	uint8 obj_pattern_cache[0x80000]; 


	uint16 Line_Cache[PCE_SCREEN_WIDTH_MAX*PCE_SCREEN_HEIGHT_MAX];


	/* Bit 0 : BG enable, Bit 1 : OBJ enable */
	int plane_enable;
	
	/* VCE color data to VGA 8-bit pixel table */
//	uint8 *xlat[2];
	
	/* VCE color data to 16-bit pixel table */
//	uint16 pixel[2][0x100];
	uint16 pixel_16bit[0x200];

	DWORD pixel_32bit[0x200];


	/* Precalculated 16-bit pixel values */
	uint16 pixel_lut_16bit[0x200];

	/*	32 bit		*/
	DWORD pixel_lut_32bit[0x200];

	/* Pointer to 8 or 16-bit version of render_line() */
	void (*render_func)(int line);

	/* List of precalculated sprite data */
	t_sprite sprite_list[0x40];
	
	/* Bitplane to packed pixel lookup table */
	uint32 bp_lut[0x10000];
	
	/* Used sprite data */
	uint8 used_sprite_list[0x40];
	uint8 used_sprite_index;
	
//	uint8 rendtptr[0x400];

#ifdef PCE_FAST_MEM
	uint8 pce_dummy[0x2000];    /* Dummy block for unknown access */
#endif
	
	char ROMname[MAX_PATH];
	char ROMPath[MAX_PATH];
	
	unsigned char *Pad[5];
	
	//	unsigned char VideoMem[0x4000];
	//	unsigned char *CartRAM;
	
	char ROMTitle[0x30];
	
	sound_buf_pos currently_playing_half;
	pce_apudata_t apu_queue[PCE_APUQUEUE_SIZE];
	int apu_qreadp;
	int apu_qwritep;


	void Save_SaveRAM();
	void Load_SaveRAM();

protected:

};



#endif
